#!/usr/bin/perl

#
# CHARM BOARD : init.cgi - 2014/10/18
# copyright (c) KentWeb
# http://www.kent-web.com/
#
# REBUILD()
#
#  CHARM BOARD v5.0 PLUS 2014/10/19
#  Edited by Hamel(TRANSFORM) Since 2012
#  http://www.transformsite.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# ݒt@CF
require "./init.cgi";
my %cf = set_init();

# f[^
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('eʃI[o[') if ($cgi->truncated);
my %in = parse_form($cgi);

# 
if ($in{mode} eq 'reg_log') { reg_log(); }
if ($in{mode} eq 'pwd') { pwd_form(); }
if ($in{mode} eq 'border') { border_page(); }
if ($in{mode} eq 'album') { album(); }
elsif ($in{mode} eq 'find') { find_data(); }
elsif ($in{mode} eq 'note') { note_page(); }
elsif ($in{mode} eq "edit_log") { edit_log(); }
elsif ($in{mode} eq 'del_log') { del_log(); }
&bbs_list;

#-----------------------------------------------------------
#  fXg
#-----------------------------------------------------------
sub bbs_list {
	my $pg = $in{pg} || 0;

	my ($i,@log);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$chk,$tim,$area,$sex,$col3,$ex,$w,$h,$check) = split(/<>/);

		# `FbN@\
		next if ($cf{adminCheck} && $chk eq '0');

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{pg_max});

		push(@log,$_);
	}
	close(IN);

	# Jz{^쐬
	my $page_btn = make_pager($i,$pg);

	# ǗbZ[W
	open(IN,"$cf{msgfile}") or &error("open err: $cf{msgfile}");
	my $msg = <IN>;
	close(IN);
	$msg = &tag($msg);

	# NbL[擾
	my ($ck_nam,$ck_col,$ck_are,$ck_sex,$ck_col3) = &get_cookie;

	# F
	my $color;
	my @col = split(/\s+/, $cf{color});
	foreach (0 .. $#col) {
		if ($ck_col == $_) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# X}CACR
	my $smile;
	my @smile = split(/\s+/, $cf{smile});
	foreach (0 .. $#smile) {
		$smile .= qq|<a href="javascript:face('{ico:$_}')"><img src="$cf{imgurl}/$smile[$_]" border="0"></a>|;
	}

	# n
	my %op;
	my @area = split(/,/, $cf{area});
	foreach (0 .. $#area) {
		if ($ck_are == $_) {
			$op{area} .= qq|<option value="$_" selected>$area[$_]\n|;
		} else {
			$op{area} .= qq|<option value="$_">$area[$_]\n|;
		}
	}

	# 
	my %op2;
	my @sex = split(/,/, $cf{sex});
	foreach (0 .. $#sex) {
		if ($ck_sex == $_) {
			$op2{sex} .= qq|<option value="$_" selected>$sex[$_]\n|;
		} else {
			$op2{sex} .= qq|<option value="$_">$sex[$_]\n|;
		}
	}

	# gFv_E
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	foreach (0 .. $#col3) {
		if ($ck_col3 == $_) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# JE^
	my $counter = bbs_count() if ($cf{counter});

	# ev[gǍ
	open(IN,"$cf{tmpldir}/bbs.html") or &error("open err: bbs.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 摜F؍쐬
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt) = cap::make( $cf{captcha_key}, $cf{cap_len} );
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# u
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!page_btn!/$page_btn/g;
	$tmpl =~ s/!form_name!/$ck_nam/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!icon!/$smile/g;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!message!/$msg/g;
	$tmpl =~ s/<!-- op_([a-z]+) -->/$op{$1}/g;
        $tmpl =~ s/<!-- op2_([a-z]+) -->/$op2{$1}/g;
        $tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s/!counter!/$counter/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/charm.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# ev[g
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3) : &error("ev[gsł");

	# wb_\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	my $i;
	foreach (@log) {
		$i++;
		my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$chk,undef,$area,$sex,$col3,$ex,$w,$h,$check) = split(/<>/);

		$com = &autolink($com) if ($cf{autolink});
		$com =~ s/\{ico:(\d+)\}/<img src="$cf{imgurl}\/$smile[$1]">/g;
		$res =~ s/\{ico:(\d+)\}/<img src="$cf{imgurl}\/$smile[$1]">/g;

		my $clip;
		# Yt
		if ($ex) {
			# mF҂
			if ($cf{imgcheck} && $check != 1) {
				my $size = get_size("$cf{upldir}/$no$ex");
				$com .= qq|<p>[Yt]: Fؑ҂ (<span style="color:#00a1e9">$size</span>)</p>|;

			# Yt摜
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{upldir}/$no-s$ex") {
					$op = qq|src="$cf{uplurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
				}
				my $size = get_size("$cf{upldir}/$no$ex");
				$clip .= qq|<div class="clip">Yt: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{ico_img}" class="clip"></a> (<span style="color:#00a1e9">$size</span>)</div>|;

			# 摜ȊO
			} else {
				my $size = get_size("$cf{upldir}/$no$ex");
				$clip .= qq|<div class="clip">Yt: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{ico_clip}" class="clip"></a> (<span style="color:#00a1e9">$size</span>)</div>|;
			}
		}

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!comment!/<span style="color:$col[$col]">$com<\/span>/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s|<!-- area -->|<img src="$cf{cmnurl}/map.png" alt="" class="icon" /> $area[$area]|g if ($area);
                $tmp =~ s|<!-- sex -->|<img src="$cf{cmnurl}/sex.png" alt="" class="icon" /> $sex[$sex]|g if ($sex);
		$tmp =~ s/!color3!/$col3/g;
		$tmp =~ s/<!-- ext -->/$clip/g;
		$tmp =~ s|<!-- res -->|<div style="color:$col[$col2]" class="res">$res</div>|g;
		#$tmp =~ s/class="bbs-art"/&line($i)/eg;
		$tmp =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?mode=pwd&no=$no"><img src="$cf{ico_edit}" title="LҏW" alt="LҏW"></a>|g;
		print $tmp;
	}

	footer($foot);
}

#-----------------------------------------------------------
#  Lr
#-----------------------------------------------------------
sub line {
	my $i = shift;

	if ($i == 1) {
		return qq|class="bbs-art line-top"|;
	} else {
		return qq|class="bbs-art line"|;
	}
}

#-----------------------------------------------------------
#  L
#-----------------------------------------------------------
sub reg_log {
	# e`FbN
	if ($cf{postonly} && $ENV{REQUEST_METHOD} ne 'POST') {
		&error("sȃNGXgł");
	}

	# ̓`FbN
	check_form();

	# 摜F؃`FbN
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		if ($in{captcha} !~ /^\d{$cf{cap_len}}$/) {
			&error("摜F؂͕słB<br>etH[ɖ߂čēǍ݌Aē͂Ă");
		}

		# eL[`FbN
		# -1 : L[sv
		#  0 : ԃI[o[
		#  1 : L[v
		$in{str_crypt} =~ s/<br>//g;
		my $chk = cap::check($in{captcha},$in{str_crypt},$cf{captcha_key},$cf{cap_time},$cf{cap_len});
		if ($chk == 0) {
			&error("摜F؂Ԃ𒴉߂܂B<br>etH[ɖ߂čēǍ݌Aw̐ē͂Ă");
		} elsif ($chk == -1) {
			&error("摜F؂słB<br>etH[ɖ߂čēǍ݌Aē͂Ă");
		}
	}

	# ͂̏ꍇ
	$in{sub} ||= "";
	$in{name} ||= "";

	# tH[e`FbN
	my $err;
	if ($in{name} eq "") { $err .= "O͂Ă܂<br />\n"; }
	elsif (length($in{name}) > $cf{max_name}*2) { $err .= "O͑Sp$cf{max_name}ȓł<br />\n"; }
	if ($in{comment} eq "") { $err .= "Rg͂Ă܂<br />\n"; }
	if (length($in{sub}) > $cf{max_sub}*2) { $err .= "^Cg͑Sp$cf{max_sub}ȓł<br />\n"; }
	if ($err) { error($err); }

	# R[hϊ
	if ($cf{conv_code} == 1) {
		require Jcode;
		$in{name} = Jcode->new($in{name})->sjis;
		$in{comment} = Jcode->new($in{comment})->sjis;
	}

	# zXg擾
	my ($host,$addr) = &get_host;

	# 폜L[Í
	my $pwd = &encrypt($in{pwd}) if ($in{pwd} ne "");

	# Ԏ擾
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @wk = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
				$year+1900,$mon+1,$mday,$wk[$wday],$hour,$min);

	# 擪Lǂݎ
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;

	# de`FbN
	my ($no,$nam,$com,$hos,$tim) = (split(/<>/, $top))[0,2,3,7,12];
	if ($in{name} eq $nam && $in{comment} eq $com) {
		close(DAT);
		&error("de͋֎~ł");
	}

	# Ae`FbN
	my $flg;
	if ($cf{regCtl} == 1) {
		if ($host eq $hos && $time - $tim < $cf{wait}) { $flg = 1; }
	} elsif ($cf{regCtl} == 2) {
		if ($time - $tim < $cf{wait}) { $flg = 1; }
	}
	if ($flg) {
		close(DAT);
		&error("ݓełB΂炭Ă瓊e肢܂");
	}

	# LNo̔
	$no++;

	# t@CYt
	my ($ext,$w,$h) = upload($no) if ($in{upfile});

	# L
	my @data = ($top);
	my $i = 0;
	while (<DAT>) {
		$i++;
		push(@data,$_);

		last if ($i >= $cf{maxlog}-1);
	}

	# XV
	seek(DAT, 0, 0);
	print DAT "$no<>$date<>$in{name}<>$in{sub}<>$in{comment}<>$in{color}<><>$pwd<>$host<><><><>0<>$time<>$in{area}<>$in{sex}<>$in{col3}<>$ext<>$w<>$h<>0<>\n";
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# [ʒm
	my $clip = "$no$ext" if ($ext);
	mail_to($date,$host,$clip) if ($cf{mailing} == 1);

	# NbL[i[
	set_cookie($in{name},$in{color},$in{sub},$in{area},$in{sex},$in{col3});

	# 
	message("肪Ƃ܂BL󗝂܂B");
}


#-----------------------------------------------------------
#  {[_[J[ETv
#-----------------------------------------------------------
sub border_page {

	# ev[gF
	open(IN,"$cf{tmpldir}/border_color.html") or &error("open err: border_color.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/charm.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1, $2, $3);
	} else {
		&error("ev[gsł");
	}

	# u
	foreach ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!version!/$cf{version}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
	}

	# ʓWJ
	print "Content-type: text/html\n\n";
	print $head;

        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	foreach (0 .. $#col3) {

		my $tmp = $loop;
		$tmp =~ s/!name!/$col4[$_]/g;
		$tmp =~ s|!color_b!|<div class="bubble2" style="border-color:$col3[$_]"><div class="rectangle2" style="background:$col3[$_]"><h2>3D CSS Ribbon</h2></div><div class="triangle2-l" style="border-color: transparent; border-bottom-color:$col3[$_];"></div><div class="triangle2-r" style="border-color: transparent; border-bottom-color:$col3[$_];"></div><div class="info2"><h2>$col4[$_]</h2></div></div>|g;
		print $tmp;
	}

	# tb^
	&footer($foot);
	exit;
}

#-----------------------------------------------------------
#  pX[htH[
#-----------------------------------------------------------
sub pwd_form {

	$in{no} =~ s/\D//g;

	# L
	my ($name,$pwd);
	open(DAT,"+< $cf{logfile}") || &error("Open Error: $cf{logfile}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$tim,$chk,$area,$sex,$col3,$ex,$w,$h,$check) = split(/<>/);

	if ($in{no} == $no) {
		$name = $name;
		$pwd = $pw;
		last;
		}
	}
	close(DAT);

	# pX[hݒ
	error("̋L̓pX[hݒ̂ߕҏWł܂") if ($pwd eq '');

	my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$tim,$chk,$area,$sex,$col3,$ex,$w,$h,$check) = split(/<>/);

	my $smile;
	my @smile = split(/\s+/, $cf{smile});
	foreach (0 .. $#smile) {
		$smile .= qq|<a href="javascript:face('{ico:$_}')"><img src="$cf{imgurl}/$smile[$_]"></a>|;
	}

	my @col = split(/\s+/, $cf{color});

		$com = &autolink($com) if ($cf{autolink});
		$com =~ s/\{ico:(\d+)\}/<img src="$cf{imgurl}\/$smile[$1]">/g;
		$res =~ s/\{ico:(\d+)\}/<img src="$cf{imgurl}\/$smile[$1]">/g;
		if (length($com) > 235) { $com = substr($com,0,230); $com .= '.....()'; }

		# Yt
		my $clip;
		if ($ex) {
			my $size = get_size("$cf{upldir}/$no$ex");
			if ($cf{imgcheck} && $chk != 1) {
				$clip = qq|<div class="clip">[Yt]: Fؑ҂ (<span style="color:#00a1e9">$size</span>)</div>|;
			} else {
				$clip = qq|<div class="clip">[Yt]: <a href="$cf{uplurl}/$no$ex" target="_blank">$no$ex</a> (<span style="color:#00a1e9">$size</span>)</div>|;
			}
		}

	my @area = split(/,/, $cf{area});
	my @sex = split(/,/, $cf{sex});

	open(IN,"$cf{tmpldir}/pwd.html") or &error("open err: pwd.html");
	my $tmpl = join('', <IN>);
	close(IN);

		# nȂ(Abvf[gȑÕO݊)
		if ($area eq "") {
			$tmpl =~ s/!area!//g;
		}
		# ʂȂ(Abvf[gȑÕO݊)
		if ($sex eq "") {
			$tmpl =~ s/!sex!//g;
		}

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/charm.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# u
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!comment!/<span style="color:$col[$col]">$com<\/span>/g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!area!/[nF$area[$area]]/g;
	$tmpl =~ s/!sex!/[ʁF$sex[$sex]]/g;
	$tmpl =~ s/!color3!/$col3/g;
	$tmpl =~ s/<!-- clip -->/$clip/;
	$tmpl =~ s|<!-- res -->|<div style="color:$col[$col2]" class="res">$res</div>|g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;

	# tb^
	footer();

	exit;
}

#-----------------------------------------------------------
#  Ao@\
#-----------------------------------------------------------
sub album {
	# y[W`
	my $pg = $in{pg} || 0;

	# 摜TCYĒ`
	$cf{max_img_w} = $cf{alb_img_w};
	$cf{max_img_h} = $cf{alb_img_h};

	# ev[gF
	open(IN,"$cf{tmpldir}/album.html") or error("open err: album.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/charm.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# ev[g
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# f[^ǂݍ
	my ($i,@img);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$chk,undef,$area,$sex,$col3,$ex,$w,$h,$check) = split(/<>/);
		next if ($cf{imgcheck} && $check eq '0');
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_albums});

		# 摜f[^W
		push(@img,"$no\t$sub\t$ex\t$w\t$h");
	}
	close(IN);

	# Jz{^
	my $page_btn = album_pgbtn($i,$pg,'&mode=album',$cf{max_albums});

	# u
	for ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!page_btn!/$page_btn/g;
		s/!bbs_title!/$cf{bbs_title}/g;
	}

	# ʓWJ
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	foreach (@img) {
		my ($no,$sub,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!image!/image($no,$ex,$w,$h)/eg;
		$tmp =~ s/!caption!/$sub/g;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  摜\
#-----------------------------------------------------------
sub image {
	my ($no,$ex,$w,$h) = @_;

	my $image;
	if (-f "$cf{upldir}/$no-s$ex") {
		$image = qq|<img src="$cf{upldir}/$no-s$ex" border="0">|;

	} else {
		($w,$h) = resize($w,$h);
		$image = qq|<img src="$cf{upldir}/$no$ex" width="$w" height="$h" border="0">|;
	}
	return qq|<a href="$cf{upldir}/$no$ex" target="_blank">$image</a>\n|;
}

#-----------------------------------------------------------
#  YtAbv[h
#-----------------------------------------------------------
sub upload {
	my $no = shift;

	# TlC@\
	require './lib/thumb.pl' if ($cf{thumbnail});

	# gq擾
	my $ext = $cgi->param_filename('upfile') =~ /(\.[^\\\/:\.]+)$/ ? $1 : error("gqs");
	$ext =~ tr/A-Z/a-z/;
	if ($ext eq '.jpeg') { $ext = '.jpg'; }

	# t@C`FbN
	check_upl($ext);

	# Ytt@C`
	my $upfile = "$cf{upldir}/$no$ext";

	# Abv[h
	open(UP,"+> $upfile") or error("up err: $upfile");
	binmode(UP);
	print UP $in{upfile};
	close(UP);

	chmod(0666, $upfile);

	# 摜TCY擾
	my ($flg,$w,$h);
	if ($ext eq ".jpg") { ($w,$h) = &j_size($upfile); $flg++; }
	elsif ($ext eq ".gif") { ($w,$h) = &g_size($upfile); $flg++; }
	elsif ($ext eq ".png") { ($w,$h) = &p_size($upfile); $flg++; }

	# TlC
	if ($flg && $cf{thumbnail}) {
		($w,$h) = &resize($w,$h);
		my $thumb = "$cf{upldir}/$no-s$ext";
		make_thumb($upfile,$thumb,$w,$h);
	}

	# ʂԂ
	return ($ext,$w,$h);
}

#-----------------------------------------------------------
#  LC
#-----------------------------------------------------------
sub edit_log {
	# ̓`FbN
	$in{num} =~ s/\D//g;
	if ($in{num} eq '' || $in{pwd} eq '') {
		&error("LNo܂͈Ï؃L[̓ł");
	}

	# Cs
	if ($in{job} eq "edit") {

	# `FbN
	if ($cf{no_wd}) { &no_wd; }
	if ($cf{jp_wd}) { &jp_wd; }
	if ($cf{urlnum} > 0) { &urlnum; }

	# ͂̏ꍇ
	$in{sub} ||= "";
	$in{name} ||= "";

	# tH[e`FbN
	my $err;
	if ($in{comment} eq "") { $err .= "Rg͂Ă܂<br>"; }
	if ($err) { &error($err); }

	# R[hϊ
	if ($cf{conv_code} == 1) {
		require "./lib/Jcode.pm";
		$in{name} = Jcode->($in{name})->sjis;
		$in{sub} = Jcode->($in{sub})->sjis;
		$in{comment} = Jcode->($in{comment})->sjis;
		$in{area} = Jcode->($in{area})->sjis;
		$in{sex} = Jcode->($in{sex})->sjis;
	}

		my ($flg,$ext2,$w2,$h2,@data);
		open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		while (<DAT>) {
			my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$chk,$tim,$area,$sex,$col3,$ext,$w,$h,$check) = split(/<>/);

			if ($in{num} == $no) {
				$flg = 1;

			# Abv[h
			if ($in{upfile}) {
				($ext2,$w2,$h2) = &upload($in{num});
			}

			# 摜폜
			if ($in{imgdel}) {
				unlink("$cf{upldir}/$in{num}$ext");
				$ext = $w = $h = '';
			}

			# YtAbv[h̏ꍇ
			if ($ext2) {
				# gqύX̏ꍇt@C폜
				if ($ext && $ext2 ne $ext) {
					unlink("$cf{upldir}/$in{num}$ext");
				}
				# VYtt@C
				($ext,$w,$h) = ($ext2,$w2,$h2);
			}

				$_ = "$no<>$date<>$in{name}<>$in{sub}<>$in{comment}<>$in{color}<><>$pw<>$hos<>$res<>$col2<><>$chk<>$tim<>$in{area}<>$in{sex}<>$in{col3}<>$ext<>$w<>$h<>0<>\n";
			}
			push(@data,$_);
		}

		# XV
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		if ($flg < 1) { &error("sȏł"); }

		# bZ[W
		&message("C܂");
	}

	my ($flg, $log);
	open(IN,"$cf{logfile}") || &error("Open Error: $cf{logfile}");
	while (<IN>) {
		my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$chk,$tim,$area,$sex,$col3,$ext,$w,$h,$check) = split(/<>/);

		if ($in{num} == $no) {

			$flg = 1;
			if ($pw eq '') {
				$flg = -1;
			}
			# Ï؃L[ƍ
			if (&decrypt($in{pwd},$pw) != 1) {
				$flg = -2;
			}
			$log = $_;
			last;
		}
	}
	close(IN);

	if (!$flg) {
		close(DAT);
		&error("YL܂");
	} elsif ($flg == 2) {
		close(DAT);
		&error("̋Lɂ͈Ï؃L[ݒ肳Ă܂");
	} elsif ($flg == 3) {
		close(DAT);
		&error("Ï؃L[Ⴂ܂");
	}

	# s
	my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$chk,$tim,$area,$sex,$col3,$ext) = split(/<>/);
	$com =~ s/<br>/\n/g;

	# F
	my $color;
	my @col = split(/\s+/, $cf{color});
	foreach (0 .. $#col) {
		if ($col == $_) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# ACR
	my $smile;
	my @smile = split(/\s+/, $cf{smile});
	foreach (0 .. $#smile) {
		$smile .= qq|<a href="javascript:face('{ico:$_}')"><img src="$cf{imgurl}/$smile[$_]"></a>|;
	}

	# n
	my %op;
	my @area = split(/,/, $cf{area});
	foreach (0 .. $#area) {
		if ($area == $_) {
			$op{area} .= qq|<option value="$_" selected>$area[$_]\n|;
		} else {
			$op{area} .= qq|<option value="$_">$area[$_]\n|;
		}
	}

	# 
	my %op2;
	my @sex = split(/,/, $cf{sex});
	foreach (0 .. $#sex) {
		if ($sex == $_) {
			$op2{sex} .= qq|<option value="$_" selected>$sex[$_]\n|;
		} else {
			$op2{sex} .= qq|<option value="$_">$sex[$_]\n|;
		}
	}

	# gFv_E
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	foreach (0 .. $#col3) {
		if ($col3[$_] eq $col3) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# Ytt@C
	my $attach;
	if ($ext) {
		$attach .= qq|&nbsp; [<a href="$cf{upldir}/$in{num}$ext" target="_blank">Yt</a>]\n|;
		$attach .= qq|<input type="checkbox" name="imgdel" value="1">폜\n|;
	}

	# CtH[
	open(IN,"$cf{tmpldir}/edit.html") or &error("open err: edit.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/charm.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/<!-- op_([a-z]+) -->/$op{$1}/g;
	$tmpl =~ s/<!-- op2_([a-z]+) -->/$op2{$1}/g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!pwd!/$pw/g;
	$tmpl =~ s/!name!/$name/;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!icon!/$smile/;
	$tmpl =~ s/!comment!/$com/;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s/<!-- attach -->/$attach/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;

	# tb^
	footer();

	exit;
}

#-----------------------------------------------------------
#  [UL폜
#-----------------------------------------------------------
sub del_log {
	# e`FbN
	if ($cf{postonly} && $ENV{REQUEST_METHOD} ne 'POST') {
		&error("sȃNGXgł");
	}

	# ̓`FbN
	$in{num} =~ s/\D//g;
	if ($in{num} eq '' || $in{pwd} eq '') {
		&error("폜No܂͍폜L[̓ł");
	}

	my ($flg,$crypt,$ext,@log);
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$date,$name,$sub,$msg,$col,$ico,$pw,$hos,$res,$col2,$ico2,$chk,$tim,$ex,$check) = split(/<>/);

		if ($in{num} == $no) {
			$flg++;
			$crypt = $pw;
			$ext = $ex;
			next;
		}
		push(@log,$_);
	}

	if (!$flg || $crypt eq '') {
		close(DAT);
		&error("폜L[ݒ肳ĂȂ͋L܂");
	}

	# 폜L[ƍ
	if (&decrypt($in{pwd}, $crypt) != 1) {
		close(DAT);
		&error("F؂ł܂");
	}

	# OXV
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# Yt폜
	if ($ext) {
		unlink("$cf{upldir}/$in{num}$ext");
		unlink("$cf{upldir}/$in{num}-s$ext") if (-f "$cf{upldir}/$in{num}-s$ext");
	}

	&message("L폜܂");
}

#-----------------------------------------------------------
#  [h
#-----------------------------------------------------------
sub find_data {
	# 
	$in{cond} =~ s/\D//g;

	# v_E
	my %op = (1 => 'AND', 0 => 'OR');
	my $op_cond;
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op_cond .= qq|<option value="$_" selected>$op{$_}\n|;
		} else {
			$op_cond .= qq|<option value="$_">$op{$_}\n|;
		}
	}

	# s
	if ($cf{conv_code} == 1) {
		require "./lib/Jcode.pm";
		$in{word} = Jcode->new($in{word})->sjis;
	}
	my @log = &search($in{word},$in{cond}) if ($in{word} ne '');

	my $smile;
	my @smile = split(/\s+/, $cf{smile});
	foreach (0 .. $#smile) {
		$smile .= qq|<a href="javascript:face('{ico:$_}')"><img src="$cf{imgurl}/$smile[$_]"></a>|;
	}

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ÔƂ
	if ($in{word} eq '') {
		$tmpl =~ s/<!-- msg_begin -->.+<!-- msg_end -->//s;
	} else {
		my $hit = @log > 0 ? @log : 0;
		$tmpl =~ s/!hit!/$hit/g;
	}

	# u
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/<!-- op_cond -->/$op_cond/;
	$tmpl =~ s/!word!/$in{word}/;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/charm.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# ev[g
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3) : &error("ev[gsł");

	my @area = split(/,/, $cf{area});
	my @sex = split(/,/, $cf{sex});
	my @col = split(/\s+/, $cf{color});

	# wb_
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# [v
	foreach (@log) {
		my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$chk,$tim,$area,$sex,$col3,$ex,$w,$h,$check) = split(/<>/);
		$com  = &autolink($com) if ($cf{autolink});
		$com =~ s/\{ico:(\d+)\}/<img src="$cf{imgurl}\/$smile[$1]">/g;
		$res =~ s/\{ico:(\d+)\}/<img src="$cf{imgurl}\/$smile[$1]">/g;

		# Yt
		my $clip;
		if ($ex) {
			my $size = -s "$cf{upldir}/$no$ex" || 0;
			if ($cf{imgcheck} && $chk != 1) {
				$clip = qq|<div class="clip2">[Yt]: Fؑ҂ ($size Bytes)</div>|;
			} else {
				$clip = qq|<div class="clip2">[Yt]: <a href="$cf{uplurl}/$no$ex" target="_blank">$no$ex</a> ($size Bytes)</div>|;
			}
		}

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!comment!/<span style="color:$col[$col]">$com<\/span>/g;
		$tmp =~ s|<!-- res -->|<div style="color:$col[$col2]" class="res2">$res</div>|g;
		$tmp =~ s/<!-- area -->/[nF$area[$area]]/g if ($area);
                $tmp =~ s/<!-- sex -->/[ʁF$sex[$sex]]/g if ($sex);
		$tmp =~ s/!color3!/$col3/g;
		$tmp =~ s/<!-- clip -->/$clip/;
		print $tmp;
	}

	# tb^
	&footer($foot);
}

#-----------------------------------------------------------
#  s
#-----------------------------------------------------------
sub search {
	my ($word,$cond) = @_;

	# L[[hz
	$word =~ s/@/ /g;
	my @wd = split(/\s+/, $word);

	# L[[hiShift-JIS`j
	my $ascii = '[\x00-\x7F]';
	my $hanka = '[\xA1-\xDF]';
	my $kanji = '[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]';

	# 
	my @log;
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$date,$name,$sub,$com,$col,$ico,$pw,$hos,$res,$col2,$ico2,$chk,$tim,$area,$sex,$col3,$ex,$w,$h,$check) = split(/<>/);

		my $flg;
		foreach my $wd (@wd) {
			if ("$name $com" =~ /^(?:$ascii|$hanka|$kanji)*?\Q$wd\E/i) {
				$flg++;
				if ($cond == 0) { last; }
			} else {
				if ($cond == 1) { $flg = 0; last; }
			}
		}
		next if (!$flg);

		push(@log,$_);
	}
	close(IN);

	# 
	return @log;
}

#-----------------------------------------------------------
#  ӎ\
#-----------------------------------------------------------
sub note_page {
	open(IN,"$cf{tmpldir}/note.html") or &error("open err: note.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_title!|$cf{bbs_title}|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/charm.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  [M
#-----------------------------------------------------------
sub mail_to {
	my ($date,$host,$clip) = @_;

	# MIMEGR[h
	require "./lib/Jcode.pm" if ($cf{conv_code} == 0);
	my $msub = Jcode->new("BBS: From $in{name}",'sjis')->mime_encode;

	# Rg̉s
	my $com = &tag($in{comment});
	$com =~ s/<br>/\n/g;
	$com =~ s/{ico:\d+}//g;

	# [{`
	my $mbody = <<"EOM";
CHARM BOARD v4.0ɓe܂B

eF$date
zXgF$host
OF$in{name}
ʁ@F$in{sex}
n@F$in{area}
YtF$clip

$com
EOM

	# JISR[hϊ
	$mbody = Jcode->new($mbody,'sjis')->jis;

	# sendmailR}h
	my $scmd = "$cf{sendmail} -t -i";
	if ($cf{sendm_f}) {
		$scmd .= " -f $cf{mailto}";
	}

	# M
	open(MAIL,"| $scmd") or &error("Ms");
	print MAIL "To: $cf{mailto}\n";
	print MAIL "From: $cf{mailto}\n";
	print MAIL "Subject: $msub\n";
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
	print MAIL "Content-Transfer-Encoding: 7bit\n";
	print MAIL "X-Mailer: $cf{version}\n\n";
	print MAIL "$mbody\n";
	close(MAIL);
}

#-----------------------------------------------------------
#  JPEGTCYF
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFTCYF
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGTCYF
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  bZ[W
#-----------------------------------------------------------
sub message {
	my ($msg) = @_;

	open(IN,"$cf{tmpldir}/message.html") or &error("open err: message.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/charm.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!message!/$msg/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  JE^
#-----------------------------------------------------------
sub bbs_count {
	# IP擾
	my $addr = $ENV{REMOTE_ADDR};

	# {̂݃JEgAbv
	my $cntup = $in{mode} eq '' ? 1 : 0;

	# JEgt@Cǂ݂
	open(LOG,"+< $cf{cntfile}") or error("open err: $cf{cntfile}");
	eval "flock(LOG, 2);";
	my $count = <LOG>;

	# IP`FbNƃOj`FbN
	my ($cnt,$ip) = split(/:/,$count);
	if ($addr eq $ip or $cnt eq "") { $cntup = 0; }

	# JEgAbv
	if ($cntup) {
		$cnt++;
		seek(LOG, 0, 0);
		print LOG "$cnt:$addr";
		truncate(LOG, tell(LOG));
	}
	close(LOG);

	# 
	while(length($cnt) < $cf{mini_fig}) { $cnt = '0' . $cnt; }
	my @cnts = split(//,$cnt);

	# GIFJE^\
	my $counter;
	if ($cf{counter} == 2) {
		foreach (0 .. $#cnts) {
			$counter .= qq|<img src="$cf{gif_path}/$cnts[$_].gif\" alt="$cnts[$_]" />|;
		}

	# eLXgJE^\
	} else {
		$counter = qq|<span style="color:$cf{cntcol}">$cnt</span>\n|;
	}
	return $counter;
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:2.5em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
++ <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  G[
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/charm.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  Jz{^쐬 (Ao)
#-----------------------------------------------------------
sub album_pgbtn {
	my ($i,$pg,$stat,$max) = @_;
	$max ||= 5;

	# y[WJz`
	my $next = $pg + $max;
	my $back = $pg - $max;

	# y[WJz{^쐬
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<span class="pg-on"><b>$x</b></span>!);
			} else {
				push(@pg,qq!<span class="pg-off"><a href="$cf{bbs_cgi}?pg=$y$stat">$x</a></span>!);
			}
			$x++;
			$y += $max;
			$z -= $max;

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<span class="pg-off"><a href="$cf{bbs_cgi}?pg=$back$stat">&lt;</a></span>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<span class="pg-off"><a href="$cf{bbs_cgi}?pg=$next$stat">&gt;</a></span>\n!;
	}
	$ret;
}

#-----------------------------------------------------------
#  y[W쐬
#-----------------------------------------------------------
sub make_pager {
	my ($i,$pg) = @_;

	# y[WJz`
	$cf{pg_max} ||= 10;
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	# y[WJz{^쐬
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>\n!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y">$x</a></li>\n!);
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next">&raquo;</a></li>\n!;
	}
	
	# ʂԂ
	return $ret ? qq|<ul class="pager">\n$ret</ul>| : '';
}

#-----------------------------------------------------------
#  N
#-----------------------------------------------------------
sub autolink {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  ֎~[h`FbN
#-----------------------------------------------------------
sub no_wd {
	my $flg;
	foreach ( split(/,/, $cf{no_wd}) ) {
		if (index("$in{name} $in{comment}", $_) >= 0) {
			$flg = 1;
			last;
		}
	}
	if ($flg) { &error("֎~[h܂܂Ă܂"); }
}

#-----------------------------------------------------------
#  {`FbN
#-----------------------------------------------------------
sub jp_wd {
	if ($in{comment} !~ /[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]/) {
		&error("bZ[Wɓ{ꂪ܂܂Ă܂");
	}
}

#-----------------------------------------------------------
#  URL`FbN
#-----------------------------------------------------------
sub urlnum {
	my $com = $in{comment};
	my ($num) = ($com =~ s|(https?://)|$1|ig);
	if ($num > $cf{urlnum}) {
		&error("RgURLAhX͍ő$cf{urlnum}܂łł");
	}
}

#-----------------------------------------------------------
#  ANZX
#-----------------------------------------------------------
sub get_host {
	# IP&zXg擾
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}

	# IP`FbN
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg = 1; last; }
	}
	if ($flg) {
		&error("ANZXĂ܂");

	# zXg`FbN
	} elsif ($host) {

		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($host =~ /$_$/i) { $flg = 1; last; }
		}
		if ($flg) {
			&error("ANZXĂ܂");
		}
	}
	if ($host eq "") { $host = $addr; }
	return ($host,$addr);
}

#-----------------------------------------------------------
#  cryptÍ
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in, $salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  cryptƍ
#-----------------------------------------------------------
sub decrypt {
	my ($in,$dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);
	if (crypt($in, $salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  ^O
#-----------------------------------------------------------
sub tag {
	local($_) = @_;

	s/&lt;/</g;
	s/&gt;/>/g;
	s/&quot;/"/g;
	s/&amp;/&/g;
	s/&#39;/'/g;
	$_;
}

#-----------------------------------------------------------
#  NbL[s
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# tH[}bg
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLGR[h
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookie_id}=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookie_id}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  ̓`FbN
#-----------------------------------------------------------
sub check_form {
	if ($cf{no_wd}) { no_wd(); }
	if ($cf{jp_wd}) { jp_wd(); }
	if ($cf{urlnum} > 0) { urlnum(); }
	$in{name} =~ s|<br />||g;
	$in{sub}  =~ s|<br />||g;
	$in{color} =~ s/\D//g;
	
	# 摜F؃`FbN
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		if ($in{captcha} !~ /^\d{$cf{cap_len}}$/) {
			error("摜F؂͕słB<br />etH[ɖ߂čēǍ݌Aē͂Ă");
		}

		# eL[`FbN
		# -1 : L[sv
		#  0 : ԃI[o[
		#  1 : L[v
		$in{str_crypt} =~ s|<br />||g;
		my $chk = cap::check($in{captcha},$in{str_crypt},$cf{captcha_key},$cf{cap_time},$cf{cap_len});
		if ($chk == 0) {
			error("摜F؂Ԃ𒴉߂܂B<br />etH[ɖ߂čēǍ݌Aw̐ē͂Ă");
		} elsif ($chk == -1) {
			error("摜F؂słB<br />etH[ɖ߂čēǍ݌Aē͂Ă");
		}
	}

	# tH[e`FbN
	my $err;
	if ($in{name} eq "") { $err .= "O͂Ă܂<br />\n"; }
	elsif (length($in{name}) > $cf{max_name}*2) { $err .= "O͑Sp$cf{max_name}ȓł<br />\n"; }
	if ($in{comment} eq "") { $err .= "Rg͂Ă܂<br />\n"; }
	if (length($in{sub}) > $cf{max_sub}*2) { $err .= "^Cg͑Sp$cf{max_sub}ȓł<br />\n"; }
	if ($err) { error($err); }

	# R[hϊ
	if ($cf{conv_code} == 1) {
		require Jcode;
		$in{name} = Jcode->new($in{name})->sjis;
		$in{comment} = Jcode->new($in{comment})->sjis;
	}
}

#-----------------------------------------------------------
#  t@Ce
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  ؂
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  t@C`FbN
#-----------------------------------------------------------
sub check_upl {
	my ($ext) = @_;

	# mime^Cv
	my $mime = $cgi->param_mime('upfile');

	my $flg;
	if ($cf{ok_gif}) {
		if ($mime =~ /^image\/gif$/i and $ext eq '.gif') { $flg++; }
	}
	if (!$flg and $cf{ok_jpeg}) {
		if ($mime =~ /^image\/p?jpe?g$/i and $ext eq '.jpg') { $flg++; }
	}
	if (!$flg and $cf{ok_pdf}) {
		if ($mime =~ /^application\/pdf$/i and $ext eq '.pdf') { $flg++; }
	}
	if (!$flg and $cf{ok_zip}) {
		if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ext eq '.zip') { $flg++; }
	}
	if (!$flg and $cf{ok_text}) {
		if ($mime =~ /^text\/plain$/i and $ext =~ /^\.te?xt$/) { $flg++; }
	}
	if (!$flg and $cf{ok_word}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ext eq '.doc') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ext eq '.docx') { $flg++; }
	}
	if (!$flg and $cf{ok_excel}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ext eq '.xls') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ext eq '.xlsx') { $flg++; }
	}
	if (!$flg and $cf{ok_ppt}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ext eq '.ppt') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ext eq '.pptx') { $flg++; }
	}

	if (!$flg) { error('̃t@C͎舵ł܂'); }
}

